/*
    Copyright 2015 Carlos Toro Peas, Madrid, Espaa 
    This file is part of Android Integral Calculator. 
    Inherted from MaximaOnAndroid project whose
    Copyright 2012, Yasuaki Honda (yasuaki.honda@gmail.com)
    
    Android Integral Calculator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Android Integral Calculator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.carlos.math.functions;

public class Interval 
{

	private double inf;
	private double sup;
	
	public Interval (double d1, double d2)
	{
		this.inf = d1;
		this.sup = d2;
	}
	
	public Interval ()
	{
		
	}
	public Interval (String d1, String d2)
	{
		this();
		d1 = arrumateString(d1);
		d2 = arrumateString(d2);
		this.inf = Double.parseDouble(d1);
		this.sup = Double.parseDouble(d2);
	}
	
	private String arrumateString(String s)
	{
		s = s.toLowerCase();
		s = s.replaceAll(",", ".");
		s = s.replaceAll("pi", "3.14159265389793238");
		s = s.replaceAll("e", "2.7182818284590452353");
		s = s.replaceAll("phi", "2.7182818284590452353");
		return s;
	}
	public double getLength()
	{
		return sup - inf;
	}
	
	public boolean belongsToMe(double d)
	{
		return d <= sup && d>= inf;
	}

	public double getInf() {
		return inf;
	}

	public void setInf(double inf) {
		this.inf = inf;
	}

	public double getSup() {
		return sup;
	}

	public void setSup(double sup) {
		this.sup = sup;
	}
	
	public String toString()
	{
		return "[" + this.inf + ", " + this.sup + "]";
	}
	
	public void reducePercent(int percent)
	{
		this.setSup(this.sup + this.sup * percent/100);
		this.setInf(this.inf + this.inf * percent/100);
	}
	
	public void reduceHalf()
	{
		this.setSup(this.sup/2);
		this.setInf(this.inf/2);
	}
	
	public void reduceDouble()
	{
		this.setSup(this.sup*2);
		this.setInf(this.inf*2);
	}
}
