/*
    Copyright 2015 Carlos Toro Peas, Madrid, Espaa 
    This file is part of Android Integral Calculator. 
    Inherted from MaximaOnAndroid project whose
    Copyright 2012, Yasuaki Honda (yasuaki.honda@gmail.com)
    
    Android Integral Calculator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Android Integral Calculator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.mathstools.integral;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import com.mathstools.integral.R;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

public class ContactActivity extends Activity
{

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.contact);
	}
	
	public String getKey(String s)
	{
		int a = getResources().getIdentifier(s, "string", getPackageName());
		String ss = null;
		if (a>0)
			ss = this.getResources().getString(a);
		else
			ss ="";
		return ss;
	}
    public void sendFeedback(View button) {  
        // Do click handling here  
    	Toast.makeText(getApplicationContext(), "Sending", Toast.LENGTH_SHORT).show();
        final EditText nameField = (EditText) findViewById(R.id.EditTextName);  
        String name = nameField.getText().toString();  
        final EditText emailField = (EditText) findViewById(R.id.EditTextEmail);  
        String email = emailField.getText().toString();  
        final EditText feedbackField = (EditText) findViewById(R.id.EditTextFeedbackBody);  
        String feedback = feedbackField.getText().toString();
        
        
        
        if(name == null || email == null || feedback == null)
        {
        	Toast.makeText(getApplicationContext(), getKey("error_all_fields"), Toast.LENGTH_SHORT).show();
        	return;
        }
        if(!validateEmail(email))
        {
        	Toast.makeText(getApplicationContext(), getKey("error_email"), Toast.LENGTH_SHORT).show();
        	return;
        }
        try 
        {
        	URL url = new URL("http://www.mathstools.com/index.php/default/receibeContact");
        	
        	HttpClient httpclient = new DefaultHttpClient();
        	HttpPost httppost = new HttpPost("http://www.mathstools.com/index.php/default/receibeContact");
        	NameValuePair n = null;
        	
        	List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
        	
        	nameValuePairs.add(new BasicNameValuePair("name", name));
        	nameValuePairs.add(new BasicNameValuePair("email",email ));
        	nameValuePairs.add(new BasicNameValuePair("text", "New Android: "+feedback ));
        	httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

        	// Execute HTTP Post Request
        	HttpResponse response = httpclient.execute(httppost);

        	String ret = EntityUtils.toString(response.getEntity());
        	
        	Toast.makeText(getApplicationContext(), getKey("thanks"), Toast.LENGTH_SHORT).show();
        }
        catch(Exception e)
        {
        	Toast.makeText(getApplicationContext(), getKey("error_connect"), Toast.LENGTH_SHORT).show();
        	e.printStackTrace();
        }
    }
    
    private boolean validateEmail(String s)
    {
    	if(s!=null && s.indexOf('.')>0 && s.indexOf('@')>0)
    	{
    		return true;
    	}
    	return false;
    }
}
