/*
    Copyright 2015 Carlos Toro Peas, Madrid, Espaa 
    This file is part of Android Integral Calculator. 
    Inherted from MaximaOnAndroid project whose
    Copyright 2012, Yasuaki Honda (yasuaki.honda@gmail.com)
    
    Android Integral Calculator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Android Integral Calculator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.mathstools.integral;

import java.lang.reflect.Method;
import java.util.Locale;

import com.mathstools.integral.R;

import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.ActivityNotFoundException;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.RelativeLayout;
//import com.google.android.maps.MyLocationOverlay;


public class IntegratorActivity extends Activity  {

	

	private String trackerName;
	private String uriFile;
	final String PREFS_NAME = "MyPrefsFile";
	//protected AlertDialog alertDialog;
	private boolean expirated = false;
	private int Times = 3;
	//protected String packageName = "com.mathstools.integrals";
	private String appPackage = null;
	private WebView mWebView;

	@TargetApi(Build.VERSION_CODES.JELLY_BEAN)
	public void pachAndroid6(WebSettings webSettings)
	{
		if(methodExists("setAllowFileAccessFromFileURLs", webSettings))
		{
			webSettings.setAllowFileAccessFromFileURLs(true);
		}
		if(methodExists("setAllowUniversalAccessFromFileURLs", webSettings))
		{
			webSettings.setAllowUniversalAccessFromFileURLs(true);
		}
	}

	private long lastPressedTime=0;
	private static final int PERIOD = 500;

	@Override
	public void onBackPressed() {

		if(System.currentTimeMillis() - lastPressedTime < PERIOD)
		{
			super.onBackPressed();
		}
		lastPressedTime = System.currentTimeMillis();
	}

/*
	private void createMenu(Menu menu)
	{
		MenuItem menu1 = menu.add(0, 0, 0, "Simplex Algorithm");
		menu1.setAlphabeticShortcut('a');
		menu1.setIcon(R.drawable.simplex);

		MenuItem menu2 = menu.add(0, 1, 0, "3D Functions");
		menu2.setAlphabeticShortcut('b');
		menu2.setIcon(R.drawable.d3);

		MenuItem menu3 = menu.add(0, 2, 0, "Matrix Studio");
		menu3.setAlphabeticShortcut('c');
		menu3.setIcon(R.drawable.matrix);

		MenuItem menu4 = menu.add(0, 3, 0, "Runge Kutta Methods");
		menu4.setAlphabeticShortcut('d');
		menu4.setIcon(R.drawable.rk);

		MenuItem menu5 = menu.add(0, 4, 0, "Rate this App");
		menu5.setAlphabeticShortcut('d');
		menu5.setIcon(R.drawable.check);

		MenuItem menu7 = menu.add(0, 6, 0, "www.mathstools.com");
		menu7.setAlphabeticShortcut('e');
		menu7.setIcon(R.drawable.mathstools1);
	}
*/
	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		super.onCreateOptionsMenu(menu);
		//createMenu(menu);
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item)
	{
		return menuChoice(item);
	}
	private void navigateTo(String url)
	{
		Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(url));
		startActivity(browserIntent);
	}

	private boolean menuChoice(MenuItem item)
	{
		switch (item.getItemId()) {
		case 0:
			intentActivity("com.mathstools.simplex", "com.mathstools.simplex.SimplexAlgorithmActivity", "Simplex Algorithm");
			return true;
		case 1:
			intentActivity("com.mathstools.grapher3d", "com.mathstools.grapher3d.MainActivity", "Functions 3D plotter");
			return true;
		case 2:
			intentActivity("com.mathstools.matrix", "com.mathstools.matrix.MatrixStudioActivity", "Matrix Studio");
			return true;
		case 4:
			navigateTo("https://play.google.com/store/apps/details?id=com.mathstools.integrals"); 
			return true;
		case 5:
			Intent contactIntent = new Intent(getApplicationContext(), ContactActivity.class);
			startActivity(contactIntent);
			return true;
		case 6:
			navigateTo("http://www.mathstools.com"); 
			return true;			
		default:
			intentActivity("com.mathstools.rungekutta", "com.mathstools.rungekutta.RungeKuttaActivity", "Runge Kutta Methods");
			return true;
		}
	}

	private void intentActivity(final String packageName, String activityName, String appName)
	{

		try {
			Intent i = new Intent();
			i.setClassName(packageName, activityName);
			startActivity(i);
		} catch (ActivityNotFoundException e) {
			AlertDialog.Builder builder = new AlertDialog.Builder(IntegratorActivity.this);
			builder.setMessage("App "+ appName +" is not instaled yet. Install it now?")
			.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					navigateTo("https://play.google.com/store/apps/details?id=" + packageName);
				}
			})
			.setNegativeButton("No", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					dialog.dismiss();
				}
			});
			// Create the AlertDialog object and return it
			AlertDialog alertDialog = builder.create();

			alertDialog.show();
		}
	}

	@Override
	public void onStart() {
		super.onStart();
	}

	@Override
	public void onStop() {
		super.onStop();


	}
/*
	private void initAnalytics()
	{
		analytics = GoogleAnalytics.getInstance(this);
		analytics.setLocalDispatchPeriod(1800);

		tracker = analytics.newTracker("UA-26288324-2"); // Replace with actual tracker/property Id
		tracker.enableExceptionReporting(true);
		tracker.enableAdvertisingIdCollection(true);
		tracker.enableAutoActivityTracking(true);
		tracker.enableAdvertisingIdCollection(true);
		
		tracker.setScreenName("main");

		tracker.send(new HitBuilders.EventBuilder()
		       .setCategory("Integrals")
		       .setAction("create")
		       .setLabel("submit")
		       .build());
	}
	*/
	@SuppressLint("JavascriptInterface") 
	public void onCreate(Bundle savedInstanceState) {

		super.onCreate(savedInstanceState);
		//initAnalytics();
		SharedPreferences settings = getSharedPreferences(PREFS_NAME, 0);
		this.Times = settings.getInt("times", 0);
		this.Times ++;
		settings.edit().putInt("times", Times).commit(); 

		this.initApp();

		setContentView(R.layout.main2);
		mWebView = (WebView) findViewById(R.id.webview2);


		mWebView.setScrollBarStyle(WebView.SCROLLBARS_OUTSIDE_OVERLAY);

		WebSettings webSettings = mWebView.getSettings();
		webSettings.setJavaScriptEnabled(true);
		//if(android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.ICE_CREAM_SANDWICH_MR1) {
		pachAndroid6(webSettings);
		//}

		mWebView.setWebViewClient(new WebViewClient() {
			private boolean inited=false;


			@Override
			public void onPageStarted(WebView view, String url, Bitmap favicon) {

				super.onPageStarted(view, url, favicon);

				if(!inited)
				{
					findViewById(R.id.imageLoading2).setVisibility(View.VISIBLE);
					findViewById(R.id.progressBar1).setVisibility(View.VISIBLE);
					findViewById(R.id.textLoading1).setVisibility(View.VISIBLE);
					findViewById(R.id.textLoading2).setVisibility(View.VISIBLE);
					if(Times <= 2)
					{

						findViewById(R.id.textLoading3).setVisibility(View.VISIBLE);
						//findViewById(R.id.button1).setVisibility(View.GONE);
						//findViewById(R.id.button_contact).setVisibility(View.GONE);
					}
					else
					{
						findViewById(R.id.textLoading3).setVisibility(View.GONE);
						//findViewById(R.id.button1).setVisibility(View.VISIBLE);
						//findViewById(R.id.button_contact).setVisibility(View.VISIBLE);
					}
				}
			}

			@Override
			public void onPageFinished(WebView view, String url) {
				RelativeLayout r = (RelativeLayout) findViewById(R.id.main_Layout);
				r.setBackgroundColor(0);
				if(!inited)
				{
					findViewById(R.id.imageLoading2).setVisibility(View.GONE);
					findViewById(R.id.progressBar1).setVisibility(View.GONE);
					findViewById(R.id.textLoading1).setVisibility(View.GONE);
					findViewById(R.id.textLoading3).setVisibility(View.GONE);
					findViewById(R.id.textLoading2).setVisibility(View.GONE);
					//findViewById(R.id.button1).setVisibility(View.GONE);
					//findViewById(R.id.button_contact).setVisibility(View.GONE);
				}
				findViewById(R.id.webview2).setVisibility(View.VISIBLE);
				inited = true;
			}
		});

		//mWebView.setOnTouchListener(k);


		//final Button button = (Button) findViewById(R.id.button1);
		/*
	        button.setOnClickListener(new View.OnClickListener() {
	             public void onClick(View v) {
	                 // Perform action on click

	             }
	         });*/

		mWebView.loadUrl(uriFile);
		// mWebView.setVisibility(View.GONE);
/*
		int status = GooglePlayServicesUtil.isGooglePlayServicesAvailable(getApplicationContext());
		if(status == ConnectionResult.SUCCESS) {
			//Success! Do what you want
			try
			{

				adView = (AdView)this.findViewById(R.id.adView);
				//adView2 = (AdView)this.findViewById(R.id.adView2);

				AdRequest adRequest = new AdRequest.Builder()

				//.addTestDevice(AdRequest.DEVICE_ID_EMULATOR)       // Emulator
				//.addTestDevice("4AB8EF7A06B34F50AE76A4C9A1D8D8ED") // My Galaxy Nexus test phone

				.build();
				//AdRequest adRequest2 = new AdRequest.Builder().build();
				
				//adView.setAdSize(AdSize.SMART_BANNER);
				adView.loadAd(adRequest);
				//        		adView2.loadAd(adRequest2);

			}
			catch(Exception e){
				e.printStackTrace();
			}
		}
*/

	}

/*
	@Override
	public void onPause() {

		if(adView!=null)
			adView.pause();
		//		if(adView2!=null)
		//		    adView2.pause();
		super.onPause();
	}

	@Override
	public void onResume() {
		super.onResume();

		if(adView!=null)
			adView.resume();

	}

	@Override
	public void onDestroy() {

		if(adView!=null)
			adView.destroy();
		//		  
		//		  if(adView2!=null)
		//			  adView2.destroy();

		super.onDestroy();
	}
	private AdView adView;//,adView2;
*/
	public void initApp() {
		config();
	}

	public void navigateRate(View view) {
		// Kabloey
		navigateTo("https://play.google.com/store/apps/details?id=com.mathstools.integrals"); 
	}

	public void contactForm(View view) {
		Intent contactIntent = new Intent(getApplicationContext(), ContactActivity.class);
		startActivity(contactIntent);
	}

	public void showMenu(View view) {
		// Kabloey
		openOptionsMenu();
	}

	public void config() {
		// TODO Auto-generated method stub
		this.trackerName="IntegratorAndroid";
		this.uriFile = !this.getIdiom().equals("es") || true ?  "file:///android_asset/www/index2.html" : "file:///android_asset/www/index2.html";
	}

	public String getIdiom()
	{
		Locale l = getApplicationContext().getResources().getConfiguration().locale;
		String idiom = l.getDefault().toString();
		if(idiom!= null && idiom.indexOf("es") >=0 )
		{
			return "es";
		}
		return "en";
	}

	public boolean methodExists(String methodName, WebSettings webSettings)
	{

		Method [] methods = webSettings.getClass().getMethods();
		for(Method m: methods)
		{
			if(!m.getName().equals(methodName))
			{
				continue;
			}
			else
			{
				return true;
			}
		}
		return false;
	}
}