/*
    Copyright 2015 Carlos Toro Peas, Madrid, Espaa 
    This file is part of Android Integral Calculator. 
    Inherted from MaximaOnAndroid project whose
    Copyright 2012, Yasuaki Honda (yasuaki.honda@gmail.com)
    
    Android Integral Calculator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Android Integral Calculator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.mathstools.integral;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Currency;
import java.util.List;

import android.R.string;
import android.animation.Animator;
import android.animation.AnimatorListenerAdapter;
import android.annotation.SuppressLint;
import android.annotation.TargetApi;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.inputmethodservice.Keyboard;
import android.inputmethodservice.KeyboardView;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.view.WindowManager;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.view.inputmethod.InputMethodManager;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import com.carlos.math.functions.Interval;
import com.carlos.math.functions.LPException;
import com.carlos.math.functions.PointRepresentable;
import com.carlos.math.functions.VariabledFunction;
import com.carlos.math.numerico.fourier.Coeficent;
import com.carlos.math.numerico.fourier.FourierSerie;
import com.mathstools.integral.db.DatabaseHandler;
import com.mathstools.integral.db.Function;
import com.mathstools.integral.solver.EquationSolver;
import com.mathstools.integral.utils.Solution;
import com.mathstools.integral.utils.Utils;
/*
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;
*/
import com.mathstools.integral.R;
import com.mathstools.keyboard.KeyboardListener;


@SuppressLint("JavascriptInterface") public class MainActivity extends Activity implements TextView.OnEditorActionListener,OnItemClickListener, OnItemSelectedListener
{
	private AutoCompleteTextView _editText;
	private EditText _editTexta, _ediTextb, _editTextEqn1, _editTextEqn2;
	private WebView webview;
	private ScrollView scview;
	private CommandExec sce;
	private File internalDir;
	private File externalDir;

	private ArrayAdapter<String> adapter;
	private MaximaVersion mvers=new MaximaVersion(5,28,0);
	private ProgressDialog dialog;
	
	private void updateFunctions()
	{
		webview.loadUrl("javascript:updateFunction('"+ Utils.rerereplace(_editText.getText().toString()) +"', 'function')");
		webview.loadUrl("javascript:updateFunction('"+ _editTexta.getText().toString() +"', 'a')");
		webview.loadUrl("javascript:updateFunction('"+ _ediTextb.getText().toString() +"', 'b')");
		webview.loadUrl("javascript:updateFunction('"+ _editTextEqn1.getText().toString() +"', 'eqn1')");
		webview.loadUrl("javascript:updateFunction('"+ _editTextEqn2.getText().toString() +"', 'eqn2')");
	}
		@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	//	updateFunctions();
	}
	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onRestart();
		//updateFunctions();
	}

	private long lastPressedTime=0;
	private static final int PERIOD = 500;
	
	@Override
	public void onBackPressed() {
		
		this.hideAllKeyBoards();
		if(System.currentTimeMillis() - lastPressedTime < PERIOD)
		{
			super.onBackPressed();
		}
		lastPressedTime = System.currentTimeMillis();
	}

	public EditText get_editTextEqn1() {
		return _editTextEqn1;
	}

	public void set_editTextEqn1(EditText _editTextEqn1) {
		this._editTextEqn1 = _editTextEqn1;
	}

	public EditText get_editTextEqn2() {
		return _editTextEqn2;
	}

	public void set_editTextEqn2(EditText _editTextEqn2) {
		this._editTextEqn2 = _editTextEqn2;
	}

	public void hideSoftKeyboard() {
		Object o = getSystemService(Activity.INPUT_METHOD_SERVICE);
		if(o != null)
		{
			InputMethodManager inputMethodManager = (InputMethodManager)  getSystemService(Activity.INPUT_METHOD_SERVICE);
			if(inputMethodManager != null && getCurrentFocus() != null && getCurrentFocus().getWindowToken() != null)
			{
				inputMethodManager.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);

			}
		}
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		// TODO Auto-generated method stub
		System.out.println("ESSO");
		return super.onTouchEvent(event);
	}

	private Menu menu;
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		// Inflate the menu; this adds items to the action bar if it is present.
		this.menu = menu;
		getMenuInflater().inflate(R.menu.menu, menu);
		isShowingFunctionsMode();
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case R.id.exit:
			finish();
			return true;
		case R.id.equations_solver:
			showEquationsSolver();
			return true;
		case R.id.show_help:
			showHelp();
			return true;
		case R.id.about:
			showAbout();
			return true;
		case R.id.rate:
			navigateTo("https://play.google.com/store/apps/details?id=com.mathstools.integrals");
			return true;
		case R.id.contact_form:
			Intent contactIntent = new Intent(getApplicationContext(), ContactActivity.class);
			startActivity(contactIntent);
			return true;
		}
		return true;
	}
	private void showHelp()
	{
		webview.loadUrl("javascript:showHelp()");
	}
	private void showAbout()
	{
		webview.loadUrl("javascript:showAbout()");
	}
	private void navigateTo(String url)
	{
		Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(url));
		startActivity(browserIntent);
	}
	public void addAutoList(String s)
	{
		DatabaseHandler db = new DatabaseHandler(this);
		db.insert(new Function(s));
		
		db.close();
		
	}
	public void setAutoList(String s)
	{
		DatabaseHandler db = new DatabaseHandler(this);
		adapter = new ArrayAdapter<String>(this, android.R.layout.simple_dropdown_item_1line, db.read(s));
		db.close();
		_editText.setAdapter(adapter);

	}
	
	public boolean methodExists(String methodName, android.webkit.WebSettings webSettings)
	{
		
		 java.lang.reflect.Method [] methods = webSettings.getClass().getMethods();
		 for(java.lang.reflect.Method m: methods)
		 {
			 if(!m.getName().equals(methodName))
			 {
				 continue;
			 }
			 else
			 {
				 return true;
			 }
		 }
		 return false;
	}
	
	@TargetApi(Build.VERSION_CODES.JELLY_BEAN)
	public void pachAndroid6(android.webkit.WebSettings webSettings)
	{
		if(methodExists("setAllowFileAccessFromFileURLs", webSettings))
		{
			webSettings.setAllowFileAccessFromFileURLs(true);
		}
		if(methodExists("setAllowUniversalAccessFromFileURLs", webSettings))
		{
			webSettings.setAllowUniversalAccessFromFileURLs(true);
		}
		if(methodExists("setBlockNetworkLoads", webSettings))
		{
			webSettings.setBlockNetworkLoads(false);
		}
	}
	
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		internalDir = this.getFilesDir();
		externalDir = this.getExternalFilesDir(null);

		webview = (WebView) findViewById(R.id.webView1);
		webview.getSettings().setJavaScriptEnabled(true); 
		
		webview.setScrollBarStyle(WebView.SCROLLBARS_OUTSIDE_OVERLAY);
		
		pachAndroid6(webview.getSettings());
		//webview.setWebViewClient(new WebViewClient() {}); 
		//webview.getSettings().setBuiltInZoomControls(true);
		//ScrollView v = (ScrollView)findViewById(R.id.scrollView1);
		//v.setY(v.getHeight());
		
		webview.setWebViewClient(new WebViewClient() {
			@Override
			public void onPageStarted(WebView view, String url, Bitmap favicon) {
				hideAllKeyBoards();
				hideSoftKeyboard();
				if(dialog == null)
				{
					dialog = new ProgressDialog(MainActivity.this);
					// dialog.setTitle(R.string.installing);
					dialog.setIcon(R.drawable.m_slogan);
					dialog.setMessage(MainActivity.this.getResources().getString(R.string.initializing));
					dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
					dialog.setCancelable(false);  
					dialog.setMax(100);
					dialog.setProgress(0);
				}
				dialog.show();
			}
			@Override
			public void onPageFinished(WebView view, String url) {
				ScrollView v = (ScrollView)findViewById(R.id.scrollView1);
				/*v.animate().translationY(-v.getHeight())
				.alpha(1.0f);
				v.setAlpha(1);
				*/
				v.setVisibility(View.VISIBLE);
				findViewById(R.id.editText1).clearFocus();
				//findViewById(R.id.showHideButton2).requestFocus();
				webview.requestFocus();
				new Thread(new Runnable() {
					
					@Override
					public void run() {
						// TODO Auto-generated method stub
						try {
							Thread.currentThread().sleep(4000);
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
							dialog.dismiss();
						} // sleeps for two seconds
						dialog.dismiss();
					}
				}).start();
				
			}
		});
		
		
		//scview = (ScrollView) findViewById(R.id.scrollView1);

		webview.loadUrl("file:///android_asset/index2.html?a=l");
		webview.addJavascriptInterface(this, "MOA");
		webview.bringToFront();

		Keyboard mKeyboard= new Keyboard(this.getApplicationContext(),R.xml.key);
		//Keyboard mKeyboardNumeric= new Keyboard(this.getApplicationContext(),R.xml.key_numeric);

		KeyboardView mKeyboardView = (KeyboardView)findViewById(R.id.keyboardview);
		KeyboardView mKeyboardViewa = (KeyboardView)findViewById(R.id.keyboardviewa);
		KeyboardView mKeyboardViewb = (KeyboardView)findViewById(R.id.keyboardviewb);
		KeyboardView mKeyboardViewEqn1 = (KeyboardView)findViewById(R.id.keyboardviewEqn1);
		KeyboardView mKeyboardViewEqn2 = (KeyboardView)findViewById(R.id.keyboardviewEqn2);
		

		mKeyboardView.setKeyboard( mKeyboard );
		mKeyboardViewa.setKeyboard( mKeyboard );
		mKeyboardViewb.setKeyboard( mKeyboard );
		mKeyboardViewEqn1.setKeyboard( mKeyboard );
		mKeyboardViewEqn2.setKeyboard( mKeyboard );
		
		mKeyboardView.setPreviewEnabled(false);

		_editText=(AutoCompleteTextView)findViewById(R.id.editText1);
		_editTexta=(EditText)findViewById(R.id.editTexta);
		_ediTextb=(EditText)findViewById(R.id.editTextb);

		_editTextEqn1=(EditText)findViewById(R.id.editTextEqn1);
		_editTextEqn2=(EditText)findViewById(R.id.editTextEqn2);

		_editText.setThreshold(1);

		getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);

		KeyboardListener k = new KeyboardListener(_editText, mKeyboardView, webview, this, "function");
		KeyboardListener ka = new KeyboardListener(_editTexta, mKeyboardViewa, webview, this, "a");
		KeyboardListener kb = new KeyboardListener(_ediTextb, mKeyboardViewb, webview, this, "b");
		KeyboardListener kEqn1 = new KeyboardListener(_editTextEqn1, mKeyboardViewEqn1, webview, this, "ifunction1");
		KeyboardListener kEqn2 = new KeyboardListener(_editTextEqn2, mKeyboardViewEqn1, webview, this, "ifunction2");
		
		mKeyboardView.setOnKeyboardActionListener(k);

		_editText.setOnItemSelectedListener(this);
		_editText.setOnItemClickListener(this);

		_editText.setOnEditorActionListener(this);
		_editText.setOnClickListener(k);
		_editText.setOnFocusChangeListener(k);
		_editText.setOnTouchListener(k);

		mKeyboardViewa.setOnKeyboardActionListener(ka);
		_editTexta.setOnEditorActionListener(this);
		_editTexta.setOnClickListener(ka);
		_editTexta.setOnFocusChangeListener(ka);
		_editTexta.setOnTouchListener(ka);

		mKeyboardViewb.setOnKeyboardActionListener(kb);
		_ediTextb.setOnEditorActionListener(this);
		_ediTextb.setOnClickListener(kb);
		_ediTextb.setOnFocusChangeListener(kb);
		_ediTextb.setOnTouchListener(kb);

		mKeyboardViewEqn1.setOnKeyboardActionListener(kEqn1);
		_editTextEqn1.setOnEditorActionListener(this);
		_editTextEqn1.setOnClickListener(kEqn1);
		_editTextEqn1.setOnFocusChangeListener(kEqn1);
		_editTextEqn1.setOnTouchListener(kEqn1);
		
		mKeyboardViewEqn2.setOnKeyboardActionListener(kEqn2);
		_editTextEqn2.setOnEditorActionListener(this);
		_editTextEqn2.setOnClickListener(kEqn2);
		_editTextEqn2.setOnFocusChangeListener(kEqn2);
		_editTextEqn2.setOnTouchListener(kEqn2);
		
		MaximaVersion prevVers=new MaximaVersion();
		prevVers.loadVersFromSharedPrefs(this);
		long verNo = prevVers.versionInteger();
		long thisVerNo = mvers.versionInteger();
		
		if ((thisVerNo > verNo) || !((new File(internalDir+"/maxima")).exists()))  {
			Intent intent = new Intent(this,InstallerActivity.class);
			intent.setAction(Intent.ACTION_VIEW);
			intent.putExtra("version", mvers.versionString());
			this.startActivityForResult(intent,0);
		} else {
			startMaxima();
		}
		hideAllKeyBoards();
		hideSoftKeyboard();
/*
		try
		{

			adView = (AdView)this.findViewById(R.id.adView);
	
			AdRequest adRequest = new AdRequest.Builder().build();

			adView.loadAd(adRequest);
		}
		catch(Exception e){
			e.printStackTrace();
		}
		*/
	}

	
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
/*
		if(adView!=null)
			adView.resume();
*/
		updateFunctions();
	}

	
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		/*
		if(adView!=null)
			adView.pause();
			*/
		super.onPause();
	}
	
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		/*
		if(adView!=null)
			adView.destroy();
			*/
		super.onDestroy();
	}
	

//	private AdView adView;//,adView2;
	
	public EditText get_editTexta() {
		return _editTexta;
	}

	public void set_editTexta(EditText _editTexta) {
		this._editTexta = _editTexta;
	}

	public EditText get_ediTextb() {
		return _ediTextb;
	}

	public void set_ediTextb(EditText _ediTextb) {
		this._ediTextb = _ediTextb;
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data){
		if (resultCode==RESULT_OK) {
			/* everything is installed properly. */
			mvers.saveVersToSharedPrefs(this);
			startMaxima();
		} else {
			new AlertDialog.Builder(this)
			.setTitle("MaximaOnAndroid Installer")
			.setMessage("The installation NOT completed. Please uninstall this apk and try to re-install again.")
			.setPositiveButton("OK", new DialogInterface.OnClickListener() {
				@Override
				public void onClick(DialogInterface dialog, int which) {
					finish();
				}
			})
			.show();
		}
	}


	private void startMaxima() {
		if ( ! ( new File( internalDir+"/maxima-"+mvers.versionString() ) ).exists() &&
				! ( new File( externalDir+"/maxima-"+mvers.versionString() ) ).exists()) {
			this.finish();
		} 
		List<String> list = new ArrayList<String>();
		list.add(internalDir+"/maxima");
		list.add("--init-lisp="+internalDir+"/init.lisp");
		sce = new CommandExec();
		Log.d("My Test", "Clicked!2");
		try {
			sce.execCommand(list);
		} catch (Exception e) {

		}
		sce.clearStringBuilder();
		Log.d("My Test", "Clicked!3");

	}

	public void scrollToEnd() {
		Log.v("My Test", "scrollToEnd called");
		Handler handler = new Handler();
		Runnable task = new Runnable() {

			@Override
			public void run() {
				Runnable viewtask = new Runnable() {
					@Override
					public void run() {
						scview.fullScroll(ScrollView.FOCUS_DOWN);
						Log.v("My Test","scroll!");
					}
				};
				scview.post(viewtask);
			}
		};
		handler.postDelayed(task, 1000);
	}

	private boolean isNull(String s)
	{
		return s == null || s.length() == 0;
	}
	public void integrate(String s, String derivate, String a, String b)
	{
		//hideAd();
		if(isNull(s) || isNull(a) || isNull(b) || isNull(derivate))
		{
			webview.loadUrl("javascript:window.UpdateMath('Error', 'Error')");
			return;
		}
		String command = "";
		String op = "";
		switch (derivate) {
		case "diff":
			command = "diff(" + s + ",x);";
			op = getKey("derivate_return");//"Derivate of f(x) dx";
			break;
		case "parcx":
			command = "diff(" + s + ",x);";
			op = getKey("partialx_return");//"Derivate of f(x) dx";
			break;
		case "parc2x":
			command = "diff(diff(" + s + ",x),x);";
			op = getKey("partialx2_return");//"Derivate of f(x) dx";
			break;
		case "lapla":
			command="diff(diff(" + s + ", x), x) + diff(diff(" + s + ", y), y);";
			op = getKey("laplacian_return");//"Derivate of f(x) dx";
			break;
		case "grad":
			command="[diff(" + s + ", x) , diff(" + s + ", y)];";
			op = getKey("gradient_return");//"Derivate of f(x) dx";
			break;
		case "parcy":
			command = "diff(" + s + ",y);";
			op = getKey("partialy_return");//"Derivate of f(x) dx";
			break;
		case "parc2y":
			command = "diff(diff(" + s + ",y),y);";
			op = getKey("partialx2_return");//"Derivate of f(x) dx";
			break;
		case "int2":
			command = "integrate(integrate(" + s + ",x),y);";
			op = getKey("primitivexy_return");//"Integral of f(x) dx";
			break;
		case "int2_a_b":
			command = "integrate(integrate(" + s + ",x,"+a+","+b+"),y,"+a+","+b+");";
			op = getKey("integrationxy_return");//"Integral of f(x) dx";
			break;
		case "int":
			command = "integrate(" + s + ",x);";
			op = getKey("integral_return");//"Integral of f(x) dx";
			break;
		case "int_a_b":
			this.numericIntegral(a, b, s);
			command = "integrate(" + s + ",x,"+a+","+b+" );";
			op = getKey("integral_def_return");//"Integral of f(x) dx in interval ["+a+","+b+"]";

			break;
		case "taylor":
			command = "taylor(" + s + ",x,0,10);";
			op = getKey("taylor_return");//"Taylor polynomial at 0 of f with 10 terms";
			break;
		case "limit":
			command = "limit(" + s + ",x,"+a+");";
			op = getKey("limit_return");//"Limit of f at x="+a;
			break;
		case "extreme":
			try {
				command = "|" + this.calculateInflectedPoints(a, b, s);
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
				showError(getKey("error_operation_not_available"));
			}
			break;
		case "fourier_a_b":
			op = getKey("fourier_return");//"Fourier series of f in ["+a+","+b+"]";
			try {
				command = "|f" + this.fourier(a, b, s);
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
				showError(getKey("error_operation_not_available"));
			}
			break;
		case "numeric_a_b":
			op = getKey("numeric_return");//"Numeric integral of f in ["+a+","+b+"]";
			command = "*" + this.numericIntegral(a, b, s);
			break;
		default:
			break;
		}

		executeMaxima(command, op);
	}

	public void executeMaxima(String command, String op)
	{
		
		if(!command.startsWith("|"))
		{
			if(!command.startsWith("*"))
			{
				try {
					sce.maximaCmd(command + "\n");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					showError(getKey("error_operation_not_available"));
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					showError(getKey("error_operation_not_available"));
				}


				final String[] resArray2=sce.getProcessResult().split("\n");
				final String oo = op;
				sce.clearStringBuilder();

				MainActivity.this.runOnUiThread(new Runnable(){
					String[] resArray = resArray2;
					String op = oo;
					@Override
					public void run() {
						for (int i = 0 ; i < resArray.length ; i++) {
							if (resArray[i].indexOf("$$") != -1) {
								String reststr=resArray[i];
								while (reststr.indexOf("$$") != -1) {
									int start=reststr.indexOf("$$");
									reststr=reststr.substring(start+2);
									int end=reststr.indexOf("$$");
									webview.loadUrl("javascript:window.UpdateMath('"+ reststr.substring(0,end) +"', '" + op + ":')");
									reststr=reststr.substring(end+2);
								}
								if (reststr.length()>0) {
									String brstr="";
									//if (i<resArray.length-1) brstr="<br>";
									//		webview.loadUrl("javascript:window.updateText('"+ reststr + brstr +"')");
								}
							} else {
								String brstr="";
								//if (i<resArray.length-1) brstr="<br>";
								//	webview.loadUrl("javascript:window.updateText('"+ resArray[i] + brstr +"')");
							}
						}
					}
				}
						);
			}
			else // numeric integral
			{
				final String c = command != null ? command.substring(1) : getKey("not_found");
				
					final String oo = op;
					MainActivity.this.runOnUiThread(new Runnable(){
						String op = oo;
						public void run() {
							webview.loadUrl("javascript:window.UpdateMath(\""+ c + "\", '" + op + ":')");
						}
					});
				
			}
		}
		else // Inflected points
		{
			final String c = command.replace('"', '\'').substring(1);
			if(!c.startsWith("f"))
			{
				MainActivity.this.runOnUiThread(new Runnable(){

					public void run() {
						webview.loadUrl("javascript:window.UpdateExtreme(\""+ c + "\")");
					}
				});
			}
			else
			{
				final String d = c.substring(1);
				final String oo = op;
				MainActivity.this.runOnUiThread(new Runnable(){
					public void run() {
						webview.loadUrl("javascript:window.UpdateFourier(\""+ d + "\")");
					}
				});
			}
		}

	}
	
	public String getFunction()
	{
		String s = this._editText.getText().toString();
		return s;
	}
	public String numericIntegral(String x1, String x2, String function)
	{
		VariabledFunction y = null;
		double x = 0;
		double xf=0;
		try
		{  
			y = new VariabledFunction(function);
			x = x1.indexOf("inf") < 0 ? Utils.getExpression(x1, false) : 0;
			xf= x2.indexOf("inf") < 0 ? Utils.getExpression(x2, false) : 0;
		}  
		catch(Exception pe){    
			System.out.println(pe);  
		}

		double d = 0;
		try
		{
			if(x == xf)
			{
				if(x == 0)
				{
					d = y.integrateInfinite();
					return Double.toString(d);
				}
			}
			if(x1.indexOf("inf") >= 0)
			{
				d = y.integrateSemiInfinite(xf, false);
				return Double.toString(d);
			}
			if(x2.indexOf("inf") >= 0)
			{
				d = y.integrateSemiInfinite(x, true);
				return Double.toString(d);
			}
			Interval i = new Interval(x, xf);

			d = y.integrate(i);
			return Double.toString(d);
		} 
		catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
			showError(getKey("error_l1"));
			return null;
		}
	}
	
	
	public String calculateInflectedPoints(String x1, String x2, String function) throws Exception
	{
		//s = URLDecoder.decode(s, "UTF-8");
		VariabledFunction y = null;
		double x = 0;
		double xf=0;
		StringBuffer saliendo = new StringBuffer();
		try
		{  
			y = new VariabledFunction(function);
			x = Utils.getExpression(x1, false);
			xf= Utils.getExpression(x2, false);
		}  
		catch(Exception pe){    
			showError(getKey("error_operation_not_available"));
		}

		Interval i = new Interval(x, xf);
		List<Solution> soluciones = new ArrayList<Solution>();

		VariabledFunction derivate  =  y.differenciate("x");
		try 
		{
			PointRepresentable p = null;
			for(double d : y.findZeros(i.getInf(), i.getSup()))
			{
				p = new PointRepresentable();
				p.setX(d);
				p.setY(0);
				soluciones.add(new Solution("Zero", p)) ;
			}

			for(double d : derivate.findZeros(i.getInf(), i.getSup()))
			{
				p = new PointRepresentable();
				p.setX(d);
				p.setY(y.f(d));

				soluciones.add(new Solution(y.getPointDescription(d), p)) ;
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			showError(getKey("error_operation_not_available"));
		}

		saliendo.append("{'res':");
		saliendo.append("{");
		saliendo.append("'y':[");
		for(Solution solucion: soluciones)
		{
			saliendo.append("[");
			saliendo.append(solucion.getP().getX());
			saliendo.append(",");
			saliendo.append(solucion.getP().getY());
			saliendo.append(",");
			saliendo.append("\""+solucion.getDescription()+"\"");
			saliendo.append("]");
			saliendo.append(",");
		}

		saliendo.append("],");
		saliendo.append("f:\""+y.getFunctionAt(0)+"\"");
		saliendo.append("}}");
		return saliendo.toString();
	}
	public String fourier(String x1, String x2, String function) throws LPException
	{
		VariabledFunction y = null;
		double x = 0;
		double xf=0;
		StringBuffer saliendo = new StringBuffer();
		try
		{  
			y = new VariabledFunction(function);
			x = Utils.getExpression(x1, false);
			xf= Utils.getExpression(x2, false);
		}  
		catch(Exception pe){    
			showError(getKey("error_operation_not_available"));
		}

		Interval i = new Interval(x, xf);
		FourierSerie fs = null;
		try {
			fs = y.getFourierSeries(5, i, FourierSerie.KIND_FOURIER);
			fs.formateFunctions();
			fs.calculateCoeficents();
			
		} catch (LPException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			showError(getKey("error_l1"));
			throw e;
		}
		
		saliendo.append("{'res':");
		saliendo.append("{");
		saliendo.append("'an':[");
		for(Coeficent c: fs.getAn())
		{
			saliendo.append(c.getValue());
			saliendo.append(",");
		}
		saliendo.append("]");
		saliendo.append(",");
		saliendo.append("'bn':[");
		saliendo.append("0,");
		for(Coeficent c: fs.getBn())
		{
			saliendo.append(c.getValue());
			saliendo.append(",");
		}
		saliendo.append("],");
		saliendo.append("'sf':'"+fs.toFunction()+"'");
		saliendo.append("}");
		saliendo.append("}");
		return saliendo.toString();
	}
	public boolean onEditorAction(TextView testview, int id, KeyEvent keyEvent) {
		String cmdstr="";
		String edit = "fun";
		if(testview.equals(this._ediTextb))
			edit = "b";
		if(testview.equals(this._editTexta))
			edit = "a";

		if ((keyEvent == null) || (keyEvent.getAction()==KeyEvent.ACTION_UP)) {
			try {
				cmdstr=_editText.getText().toString();
				if (cmdstr.equals("quit();")) this.finish();
				if (maxima_syntax_check(cmdstr)) {
					sce.maximaCmd(cmdstr+"\n");
				} else {
					showError(getKey("error_syntax"));
					return false;
				}
			} catch (IOException e) {
				e.printStackTrace();
				showError(getKey("error_syntax"));
			} catch (Exception e) {
				e.printStackTrace();
				showError(getKey("error_syntax"));
			}

			if(edit.equals("fun"))
				webview.loadUrl("javascript:window.UpdateText('"+ escapeChars(cmdstr) +"<br>" +"')");
			String[] resArray=sce.getProcessResult().split("\n");
			sce.clearStringBuilder();

			for (int i = 0 ; i < resArray.length ; i++) {
				if (resArray[i].indexOf("$$") != -1) {
					String reststr=resArray[i];
					while (reststr.indexOf("$$") != -1) {
						int start=reststr.indexOf("$$");
						reststr=reststr.substring(start+2);
						int end=reststr.indexOf("$$");
						webview.loadUrl("javascript:window.UpdateMath('"+ reststr.substring(0,end) +"')");
						reststr=reststr.substring(end+2);
					}
					if (reststr.length()>0) {
						String brstr="";
						if (i<resArray.length-1) brstr="<br>";
						webview.loadUrl("javascript:window.UpdateText('"+ reststr + brstr +"')");
					}
				} else {
					String brstr="";
					if (i<resArray.length-1) brstr="<br>";
					webview.loadUrl("javascript:window.UpdateText('"+ resArray[i] + brstr +"')");
				}
			}
		}
		return true;
	}

	public void showError(String message)
	{
		//webview.loadUrl("javascript:showError('"+ message +"')");
		final String s  = message;
		webview.post(new Runnable() {
		    @Override
		    public void run() {
		    	webview.loadUrl("javascript:showError('"+ s +"')");
		    }
		});
	}
	
	private boolean maxima_syntax_check(String cmd) {
		if (!cmd.endsWith(";") && !cmd.endsWith("$")) return false;
		if (cmd.endsWith(";;")) return false;
		return true;
	}

	private String escapeChars(String cmd) {
		return substitute(cmd, "'", "\\'");
	}

	static private String substitute(String input, String pattern, String replacement) {

		int index = input.indexOf(pattern);

		if(index == -1) {
			return input;
		}

		StringBuffer buffer = new StringBuffer();

		buffer.append(input.substring(0, index) + replacement);

		if(index + pattern.length() < input.length()) {
			String rest = input.substring(index + pattern.length(), input.length());
			buffer.append(substitute(rest, pattern, replacement));
		}
		return buffer.toString();
	}

	@Override
	public void onItemSelected(AdapterView<?> arg0, View arg1, int position,
			long arg3) {
		// TODO Auto-generated method stub
		Log.d("AutocompleteContacts", "onItemSelected() position " + position);
		Toast.makeText(getBaseContext(), "ItemSelected Position:"+position+" Month:"+arg0.getItemAtPosition(position),
				Toast.LENGTH_LONG).show();
	}

	@Override
	public void onNothingSelected(AdapterView<?> arg0) {
		// TODO Auto-generated method stub

		InputMethodManager imm = (InputMethodManager) getSystemService(
				INPUT_METHOD_SERVICE);
		imm.hideSoftInputFromWindow(getCurrentFocus().getWindowToken(), 0);

	}

	@Override
	public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		// TODO Auto-generated method stub

		// Show Alert       
		/*
		Toast.makeText(getBaseContext(), "ItemClick Position:"+arg2+" Month:"+arg0.getItemAtPosition(arg2),
				Toast.LENGTH_LONG).show();
				*/

	//	Log.d("AutocompleteContacts", "Position:"+arg2+" Month:"+arg0.getItemAtPosition(arg2));

	}

	
	public void hideAd()
	{
		/*
		this.adView.animate()
	    .translationY(0).setDuration(3000)
	    .alpha(0.0f)
	    .setListener(new AnimatorListenerAdapter() {
		    @Override
	        public void onAnimationEnd(Animator animation) {
	            super.onAnimationEnd(animation);
	            adView.setVisibility(View.GONE);
	        }
	    });
	    */
	}
	
	public void showEquationsSolver()
	{
		final LinearLayout lin2 = (LinearLayout) findViewById(R.id.linear0);
		final View v = findViewById(R.id.linear_equation);
		if(isShowingFunctionsMode())
		{
			lin2.animate().translationX(lin2.getWidth())
			.alpha(1.0f);
			v.setVisibility(View.VISIBLE);
			findViewById(R.id.editText1).clearFocus();
			findViewById(R.id.editTextEqn1).clearFocus();
			showingFunctionsMode = false;
		}
		else
		{
			v.setVisibility(View.GONE);
			lin2.animate().translationX(0)
			.alpha(1.0f);
			findViewById(R.id.editText1).clearFocus();
			findViewById(R.id.editTextEqn1).clearFocus();
		    showingFunctionsMode = true;
		}
		hideAllKeyBoards();
		webview.loadUrl("javascript:toggleDivs()");
	}
	boolean showed = false;
	private boolean showingFunctionsMode = true;
	
	private boolean isShowingFunctionsMode()
	{
		//LinearLayout lin2 = (LinearLayout) findViewById(R.id.linear0);
		//float a = lin2.getX();
		
		if(menu == null || menu.getItem(0) == null)
		{
			return showingFunctionsMode;
		}
		if(!showed || !showingFunctionsMode)
		{
			menu.getItem(0).setTitle(getKey("equations_solver"));
		}
		else
		{
			menu.getItem(0).setTitle(getKey("integration"));
			
		}
		showed = true;
		return showingFunctionsMode;
	}
	
	public void hideAllKeyBoards()
	{
		findViewById(R.id.keyboardview).setVisibility(View.GONE);;
		findViewById(R.id.keyboardviewa).setVisibility(View.GONE);
		findViewById(R.id.keyboardviewb).setVisibility(View.GONE);
		findViewById(R.id.keyboardviewEqn1).setVisibility(View.GONE);
		findViewById(R.id.keyboardviewEqn2).setVisibility(View.GONE);
	}
	
	
	/*
	
	public void toggleScreen(View v)
	{
		View lin1 = findViewById(R.id.linear_1);
		ScrollView linPresentation = (ScrollView)findViewById(R.id.scrollView1);
		float i = lin1.getY();
		if(Math.abs(i)<=51)
		{
			float r = -lin1.getHeight()+40;
			lin1.animate().translationY(r).alpha(1.0f);
			linPresentation.animate().translationY(r).alpha(1.0f);
			DisplayMetrics metrics = new DisplayMetrics();
			getWindowManager().getDefaultDisplay().getMetrics(metrics);
			LinearLayout.LayoutParams l = new LinearLayout.LayoutParams(linPresentation.getWidth(), metrics.heightPixels-60);
			linPresentation.setLayoutParams(l);
			//animateGrow(linPresentation);
		}
		else
		{
			lin1.animate().translationY(0).alpha(1.0f);
			linPresentation.animate().translationY(0).alpha(1.0f);
			LinearLayout.LayoutParams l = new LinearLayout.LayoutParams(linPresentation.getWidth(), LinearLayout.LayoutParams.WRAP_CONTENT);
			linPresentation.setLayoutParams(l);
			//animateGrow(linPresentation);
		}
	}
	
	public void animateGrow(View view){
	    
	    view.setVisibility(LinearLayout.VISIBLE);
	    Animation animation   =    AnimationUtils.loadAnimation(this, R.xml.anim);
	    animation.setDuration(500);
	    view.setAnimation(animation);
	    view.animate();
	    animation.start();
	 }
	*/
	public void showHelp(View view)
	{
		webview.loadUrl("javascript:showHelp()");
	}
	
	public String getKey(String s)
	{
		int a = getResources().getIdentifier(s, "string", getPackageName());
		String ss = null;
		if (a>0)
			ss = this.getResources().getString(a);
		else
			ss ="";
		return ss;
	}
	
	private EquationSolver equationSolver;


	public EquationSolver getEquationSolver() {
		return equationSolver;
	}

	public void setEquationSolver(EquationSolver equationSolver) {
		this.equationSolver = equationSolver;
	}
	
	public void solveEquation()
	{
		String eq1 = this._editTextEqn1.getText().toString();
		String eq2 = this._editTextEqn2.getText().toString();
		
		try
		{
			if(Utils.validFunction(eq1, this) && Utils.validFunction(eq2, this))
			{
				String command = "";
				if(eq1.indexOf('y') <0 && eq2.indexOf('y') <0)
					command = "solve(" + eq1 + "=" + eq2 + ",x);";
				else
					command = "solve(" + eq1 + "=" + eq2 + ",[x,y]);";
				
				executeMaxima(command, getKey("eq_solution"));
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	public void changeLabelFunction(boolean hasY)
	{
		TextView lblFunction = (TextView) findViewById(R.id.lblFunction); 
		lblFunction.setText(hasY ? "f(x,y)=" : "f(x) =");
	}
}