/*
    Copyright 2015 Carlos Toro Peas, Madrid, Espaa 
    This file is part of Android Integral Calculator. 
    Inherted from MaximaOnAndroid project whose
    Copyright 2012, Yasuaki Honda (yasuaki.honda@gmail.com)
    
    Android Integral Calculator is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Android Integral Calculator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.mathstools.integral;


import android.app.ActionBar.LayoutParams;

import com.mathstools.integral.R;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.LinearGradient;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.PorterDuff.Mode;
import android.graphics.PorterDuffXfermode;
import android.graphics.Shader.TileMode;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.view.Gravity;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class WellcomeActivity extends Activity implements Runnable
{
	private boolean showed = false;
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		//setContentView(R.layout.wellcome);
		
		//Get you bit map from drawable folder
		Bitmap originalImage = BitmapFactory.decodeResource(getResources(), 
				R.drawable.m_slogan);

		Bitmap bitmapWithReflection = WellcomeActivity.applyReflection(originalImage);
		
		
		//Add the image to a linear layout and display it
		LinearLayout linLayout = new LinearLayout(this);
		
		linLayout.setOrientation(LinearLayout.VERTICAL);
		linLayout.setHorizontalGravity(Gravity.CENTER_HORIZONTAL);
		linLayout.setVerticalGravity(Gravity.CENTER_VERTICAL);
	
		/*
		ImageView imageView2 = new ImageView(this);
		imageView2.setImageResource(R.drawable.linea_boli);
		linLayout.addView(imageView2 );
		*/
		
		
		//Create an Image view and add our bitmap with reflection to it
		ImageView imageView = new ImageView(this);//(ImageView)findViewById(R.id.imageMathstools);
		imageView.setImageBitmap(bitmapWithReflection);
		
		/*
		imageView.setLayoutParams(new LayoutParams( 
				LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT));
		*/
		//Create an Image view and add our bitmap with reflection to it
		
		DisplayMetrics metrics = new DisplayMetrics();
		getWindowManager().getDefaultDisplay().getMetrics(metrics);
		TextView text = new TextView(this);
		text.setTextColor(Color.WHITE);
		text.setText("Simplifying Maths");
		text.setTextSize(36);
//		text.setX(metrics.widthPixels);
		
		LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT, Gravity.CENTER_HORIZONTAL));
		params.setMargins(10,10,10,10);
		
		text.setLayoutParams(params);
		
		LayoutParams l = new LayoutParams(LayoutParams.MATCH_PARENT, 200);
		
		//l.topMargin = 400;
	
		linLayout.addView(imageView,l);
		
		linLayout.addView(text);
		
		setContentView(linLayout);
		
		//text.animate().translationX(-metrics.widthPixels).setDuration(3000).alpha(1.0f);
		new Thread(this).start();
	}

	public static Bitmap applyReflection(Bitmap mainImage) {
		// gap space between original and reflected
        final int reflectionGap = 0;
        // get image size
        int width = mainImage.getWidth();
        int height = mainImage.getHeight();

        Matrix matrix = new Matrix();
        matrix.preScale(1, -1);

        Bitmap reflectionImage = Bitmap.createBitmap(mainImage, 0, 0, width, height , matrix, false);
        //Bitmap reflectionImage = Bitmap.createBitmap(mainImage, 0, height/2, width, height/2, matrix, false);

        Bitmap reflectedBitmap = Bitmap.createBitmap(width,
                (height + height ), Config.ARGB_8888);

        Canvas canvas = new Canvas(reflectedBitmap);
        canvas.drawBitmap(mainImage, 0, 0, null);
        Paint defaultPaint = new Paint();
        canvas.drawRect(0, height, width, height + reflectionGap, defaultPaint);
        canvas.drawBitmap(reflectionImage, 0, height, null);
        
        Paint paint = new Paint();
        LinearGradient shader = new LinearGradient(0, mainImage.getHeight(), 0,
        		reflectedBitmap.getHeight() + reflectionGap, 0xf0ffffff, 0x00ffffff,
        		TileMode.CLAMP);
        paint.setShader(shader);
        paint.setXfermode(new PorterDuffXfermode(Mode.DST_IN));
        canvas.drawRect(0, height, width, reflectedBitmap.getHeight()
                + reflectionGap, paint);

        return reflectedBitmap;
        }

	@Override
	public void run() {
		// TODO Auto-generated method stub
		
		try {
			Thread.currentThread().sleep(2000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

		
		int i = android.os.Build.VERSION.SDK_INT;
		Intent contactIntent = i >= 19 ? new Intent(getApplicationContext(), MainActivity.class) : new Intent(getApplicationContext(), IntegratorActivity.class);
	//	overridePendingTransition(R.anim.slide_in, R.anim.slide_out);
		startActivity(contactIntent);
	}

	@Override
	public void onBackPressed() {
		// TODO Auto-generated method stub
		super.onBackPressed();
		finish();
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		if(showed)
		{
			finish();
			return;
		}
		showed = true;
	}

	
}
