package com.mathstools.integral.utils;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import android.app.Activity;
import android.graphics.Color;
import android.widget.Toast;

import com.carlos.math.functions.VariabledFunction;

import de.jtem.mathExpr.ExpressionConfiguration;
import de.jtem.mathExpr.evaluator.realEvaluator.Real;
import de.jtem.mathExpr.evaluator.realEvaluator.RealType;

public class Utils 
{

	public static boolean parseFunction(String function) throws Exception
	{
		VariabledFunction fun = null;
		fun = new VariabledFunction(function);
		return true;
	}

	public static double getExpression(String expression, boolean substituteInf)throws Exception
	{
		try
		{
			expression = substituteInf ? expression.replace("inf", "200000") : expression;
			VariabledFunction fun = null;
			fun = new VariabledFunction(expression);
			
			return fun.f(1);
		}
		catch(Exception e)
		{
			throw new Exception();
		}
	}

	public static boolean parseFunctionAndEvalAt1(String function) throws Exception
	{
		VariabledFunction fun = null;
		fun = new VariabledFunction(function);
		fun.evaluateAtVariable("x", 1);
		return true;
	}
	public static boolean validFunction(String function, Activity activity) throws Exception
	{
		if(!Utils.parseFunction(function))
		{
			Utils.alert(activity, "Error: function " + function + " not valid! Please, try again" );
			activity.getCurrentFocus().setBackgroundColor(Color.RED);
			return false;
		}
		return true;
	}
	public static double validValue(String function, Activity activity) throws Exception
	{
		double d = Utils.getExpression(function,true);
		if(d != -3333333)
		{
			return d;
		}
		else
		{
			Utils.alert(activity, "Error: value " + function + " not valid! Please, try again" );
			activity.getCurrentFocus().setBackgroundColor(Color.RED);
			return d;
		}
	}
	
	public static String rerereplace(String cadena)
	{
		String pattern = "\\d[x|e|cos|sin|tan|sec|csec|csc|ctan|csec|ctan|cot|asin|atan|asec|acos|acot|acsc|asinh|atanh|acosh|csech|acsch|acoth|log|pi|y]";
		cadena = rereplace(cadena, pattern);
		pattern = "[x|e|cos|sin|tan|sec|csec|csc|ctan|csec|ctan|cot|asin|atan|acos|asec|acot|acsc|asinh|atanh|acosh|csech|acsch|acoth|log|pi|y]\\d";
		pattern = "x[e|cos|sin|tan|sec|csec|csc|ctan|csec|ctan|cot|asin|atan|acos|asec|acot|acsc|asinh|atanh|acosh|csech|acsch|acoth|log|pi|y]";
		return rereplace(cadena, pattern);
	}
	public static String rereplace(String cadena, String pattern)
	{
		if(cadena == null) return "";
		String replacement = "*";
		Pattern p = Pattern.compile(pattern);
		Matcher m = p.matcher(cadena);
		List<String> listaString = new ArrayList<String>();
		List<String> replacements = new ArrayList<String>();
		int n = replacement.length();
		String subs = "";
		while(m.find())
		{
			subs = m.group().substring(0,n)+replacement+m.group().substring(n);
			
			replacements.add(m.group());
			listaString.add(subs);
		}
		
		int i = 0;
		System.out.println();
		for(String sss: replacements)
		{
			cadena = cadena.replaceAll( sss,listaString.get(i));
			
			i++;
		}
		return cadena;//.substring(0, salida.length()-subs.length());
	}
	
	public static void alert(Activity activity, String message)
	{
		Toast.makeText(activity, message, Toast.LENGTH_LONG).show();
	}
}
