package com.numerico.algebralineal;

public class Matrix extends Jama.Matrix {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public Matrix(double[][] d) {
		super(d);
		// TODO Auto-generated constructor stub
	}
	
	public boolean isInvertible()
	{
		return this.isSquareAndNoSingular();
	}
	
	public boolean isSquare()
	{
		return this.getRowDimension() == this.getColumnDimension();
	}

	public boolean isSemiDefinitePositive()
	{
		double [] eigenValues = this.eig().getRealEigenvalues();
		for(double d: eigenValues)
		{
			if(d <= 0)
			{
				return false;
			}
		}
		return true;
	}
	
	public boolean isDefinitePositive()
	{
		double [] eigenValues = this.eig().getRealEigenvalues();
		for(double d: eigenValues)
		{
			if(d < 0)
			{
				return false;
			}
		}
		return true;
	}
	public boolean isDefiniteNegative()
	{
		double [] eigenValues = this.eig().getRealEigenvalues();
		for(double d: eigenValues)
		{
			if(d > 0)
			{
				return false;
			}
		}
		return true;
	}
	public boolean isSquareAndNoSingular()
	{
		return this.isSquare() && this.det() != 0;
	}
	
	public boolean isSimetric()
	{
		for(int j=0; j< this.getColumnDimension(); j++)
		{
			for(int i =j; i< this.getRowDimension(); i++)
			{
				if(this.get(j, i) != this.get(i, j))
						return false;
			}
		}
		return true;
	}
	
}
