/* Generated By:JavaCC: Do not edit this line. Parser.java */
package de.jtem.mathExpr.parser.javacc;

//import java.util.Stack;
import java.io.Reader;
import java.io.StringReader;

import de.jtem.mathExpr.parser.Expression;
import de.jtem.mathExpr.parser.ExpressionFactory;
import de.jtem.mathExpr.parser.List;

/**
 * Parser for MathExpr library.
 * Known issues:
 * Expressions like "1 1" will be parsed as Multiplication "1*1".
 * Expressions like "(a, b, c)" (without function name) will be
 * parsed as a valid list.
 */
public class Parser implements ParserConstants {
  private ExpressionFactory exprFactory;
  /*public static void main(String args[]) throws ParseException
  {
    MathExprParser parser = new MathExprParser(System.in);
    parser.parse();
  }*/
  public Parser(Reader stream, ExpressionFactory factory)
  {
    this(stream);
    exprFactory=factory;
  }
  public static Expression parse(String exprString, ExpressionFactory expFact)
  {
    Parser parser=new Parser(new StringReader(exprString), expFact);
    try
    {
      Expression expr= parser.parse();
      return expr;
    }
    catch (ParseException e)
    {
      System.out.println("ParseException: "+e.getMessage());
      return null;
    }
  }

  final public Expression parse() throws ParseException {
  Expression parsedExpr;
    parsedExpr = expression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 6:
      jj_consume_token(6);
      break;
    case 7:
      jj_consume_token(7);
      break;
    case 0:
      jj_consume_token(0);
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return parsedExpr;}
    throw new Error("Missing return statement in function");
  }

  final public Expression expression() throws ParseException {
  Expression expr;
    expr = addition();
                    {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

/**
 * Means one or more possible sub-expressions with the lowest priority.
 */
  final public Expression addition() throws ParseException {
  Expression expr, expr2;
  int sign=0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 8:
    case 9:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 8:
        jj_consume_token(8);
         sign='+';
        break;
      case 9:
        jj_consume_token(9);
         sign='-';
        break;
      default:
        jj_la1[1] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
    //possible leading algebraic sign
      expr = multiplication();
    if(sign!=0) expr=exprFactory.createUnaryOperation(expr, sign);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 8:
      case 9:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_1;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 8:
        jj_consume_token(8);
        expr2 = multiplication();
      expr=exprFactory.createBinaryOperation(expr, expr2, '+');
        break;
      case 9:
        jj_consume_token(9);
        expr2 = multiplication();
      expr=exprFactory.createBinaryOperation(expr, expr2, '-');
        break;
      default:
        jj_la1[4] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

/**
 * Also includes implicit multiplication and function calls.
 */
  final public Expression multiplication() throws ParseException {
  Expression expr, expr2;
    expr = power();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case VAR:
      case FUN:
      case NUM:
      case 10:
      case 11:
      case 14:
      case 15:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_2;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 10:
        jj_consume_token(10);
        expr2 = power();
      expr=exprFactory.createBinaryOperation(expr, expr2, '*');
        break;
      case 11:
        jj_consume_token(11);
        expr2 = power();
      expr=exprFactory.createBinaryOperation(expr, expr2, '/');
        break;
      case VAR:
      case FUN:
      case NUM:
      case 14:
      case 15:
        expr2 = power();
      expr=exprFactory.createBinaryOperation(expr, expr2, '*');
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

  final public Expression power() throws ParseException {
  Expression expr, expr2;
    expr = atom();
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 12:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_3;
      }
      jj_consume_token(12);
      expr2 = atom();
      expr=exprFactory.createBinaryOperation(expr, expr2, '^');
    }
    {if (true) return expr;}
    throw new Error("Missing return statement in function");
  }

/**
 * All Symbols and embraced Expressions.
 */
  final public Expression atom() throws ParseException {
  Token t;
  Expression expr=null;
  List list;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NUM:
      //double constant
        t = jj_consume_token(NUM);
    {if (true) return exprFactory.createSymbol(Double.parseDouble(t.image));}
      break;
    case VAR:
      t = jj_consume_token(VAR);
    {if (true) return exprFactory.createSymbol(t.image);}
      break;
    case FUN:
      t = jj_consume_token(FUN);
      list = list();
      jj_consume_token(13);
    String fName=t.image.substring(0, t.image.length()-1);
    {if (true) return exprFactory.createFunctionCall(fName, list);}
      break;
    case 14:
      jj_consume_token(14);
      expr = expression();
      jj_consume_token(13);
    {if (true) return expr;}
      break;
    case 15:
      jj_consume_token(15);
      list = list();
      jj_consume_token(16);
    {if (true) return list;}
      break;
    default:
      jj_la1[8] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public List list() throws ParseException {
  Expression expr;
  List list=(List)exprFactory.createList();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
    case FUN:
    case NUM:
    case 8:
    case 9:
    case 14:
    case 15:
      expr = expression();
      list.addEntry(expr);
      label_4:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 17:
          ;
          break;
        default:
          jj_la1[9] = jj_gen;
          break label_4;
        }
        jj_consume_token(17);
        expr = expression();
      list.addEntry(expr);
      }
      break;
    default:
      jj_la1[10] = jj_gen;
      ;
    }
    {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  public ParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[11];
  static private int[] jj_la1_0;
  static {
      jj_la1_0();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0xc1,0x300,0x300,0x300,0x300,0xcc38,0xcc38,0x1000,0xc038,0x20000,0xc338,};
   }

  public Parser(java.io.InputStream stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  public Parser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  public Parser(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  public void ReInit(ParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[18];
    for (int i = 0; i < 18; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 11; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 18; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
